import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;
import java.util.*;

public class InversionVisualisation extends JFrame implements ActionListener{

    public JPanel pPanel, pMiddlePanel, pBoxPanel, pButtomPanel;
    public DesireAndReality pGraphPanel;
    public JButton bPrev, bNext, bMutate, bDelete;
    public JCheckBox[] cbEnds;
    public JTextField[] tfNumbers;
    public ArrayList permutations;
    public int actualIndex;
    
    public InversionVisualisation(String filename) throws IOException{
	setBounds(200,0,1000,450);
	permutations = new ArrayList();
	BufferedReader bf = new BufferedReader(new FileReader(filename));
	String[] tempstringarray =bf.readLine().split("\t");
        int[] initialPermutation = new int[tempstringarray.length * 2 + 2];
	initialPermutation[0] = 0;
	initialPermutation[initialPermutation.length-1] = initialPermutation.length - 1; 
	for(int i = 0; i < tempstringarray.length; i++){
	    if(tempstringarray[i].charAt(0) == '+'){
		initialPermutation[2*i+1] = Integer.parseInt((String)tempstringarray[i].subSequence(1,tempstringarray[i].length())) * 2 - 1;
		initialPermutation[2*i+2] = Integer.parseInt((String)tempstringarray[i].subSequence(1,tempstringarray[i].length())) * 2;   
	    }
	    else{
		initialPermutation[2*i+2] = Integer.parseInt((String)tempstringarray[i].subSequence(1,tempstringarray[i].length())) * 2 - 1;
		initialPermutation[2*i+1] = Integer.parseInt((String)tempstringarray[i].subSequence(1,tempstringarray[i].length())) * 2;   
	    }
	}
	permutations.add(initialPermutation);
	pPanel = new JPanel(new BorderLayout());
	getContentPane().add(pPanel);
	pButtomPanel = new JPanel(new GridLayout(1,4,10,10));
	bPrev = new JButton("Previous");
	bPrev.addActionListener(this);
	pButtomPanel.add(bPrev);
	bNext = new JButton("Next");
	bNext.addActionListener(this);
	pButtomPanel.add(bNext);
	bMutate = new JButton("Mutate");
	bMutate.addActionListener(this);
	pButtomPanel.add(bMutate);
	bDelete = new JButton("Delete");
	bDelete.addActionListener(this);
	pButtomPanel.add(bDelete);
	pPanel.add(pButtomPanel,"South");
	pMiddlePanel = new JPanel(new BorderLayout());
	pPanel.add(pMiddlePanel,"Center");
	pBoxPanel = new JPanel(new GridLayout(1,tempstringarray.length*3 + 3));
	tfNumbers = new JTextField[initialPermutation.length];
	for(int i = 0; i < tfNumbers.length; i++){
	    tfNumbers[i] = new JTextField("");
	    setLabel(tfNumbers[i], i, initialPermutation[i]);
	}
	cbEnds = new JCheckBox[tempstringarray.length+1];
	for(int i = 0; i < cbEnds.length; i++){
	    cbEnds[i] = new JCheckBox();
	}
	pBoxPanel.add(tfNumbers[0]);
	pBoxPanel.add(cbEnds[0]);
	for(int i = 1; i < cbEnds.length; i++){
	    pBoxPanel.add(tfNumbers[2*i-1]);
	    pBoxPanel.add(tfNumbers[2*i]);
	    pBoxPanel.add(cbEnds[i]);
	}
	pBoxPanel.add(tfNumbers[tfNumbers.length-1]);
	pMiddlePanel.add(pBoxPanel,"South");
	pGraphPanel = new DesireAndReality(this);
	pMiddlePanel.add(pGraphPanel,"Center");

	actualIndex = 0;
	bPrev.setEnabled(false);
	bNext.setEnabled(false);
	bDelete.setEnabled(false);
	show();
    }

    public static void main(String[] args) throws IOException{
	if(args.length != 0){
		new InversionVisualisation(args[0]);
	}else{
	new InversionVisualisation("permutation.txt");
	}
    }
	public void setLabel(JTextField f, int i, int p) {
		if (p % 2 == 0) {
			f.setText(p/2 + "h");
		}
		else {
			f.setText((p/2+1) + "t");		}
	}
	
	
	
    public void actionPerformed(ActionEvent e){
	if(e.getSource() == bPrev){
	    actualIndex--;
	    if(actualIndex == 0){
		bPrev.setEnabled(false);
	    }
	    bNext.setEnabled(true);
	    int[] permutation = (int[])permutations.get(actualIndex);
	    for(int i = 0; i < permutation.length; i++){
		//tfNumbers[i].setText(permutation[i]+"");
		setLabel(tfNumbers[i], i, permutation[i]);
	    }
	    pGraphPanel.paintComponent(pGraphPanel.getGraphics());//show();
	}
	if(e.getSource() == bNext){
	    actualIndex++;
	    if(actualIndex == permutations.size() - 1){
		bNext.setEnabled(false);
	    }
	    bPrev.setEnabled(true);
	    int[] permutation = (int[])permutations.get(actualIndex);
	    for(int i = 0; i < permutation.length; i++){
		//tfNumbers[i].setText(permutation[i]+"");
		setLabel(tfNumbers[i], i, permutation[i]);

	    }
	    pGraphPanel.paintComponent(pGraphPanel.getGraphics());//show();
	}
 	if(e.getSource() == bMutate){
	    //  System.out.println("you pressed mutation!");
	    int[] permutation = (int[])permutations.get(actualIndex);
	    int[] newpermutation = new int[permutation.length];
	    int begin = 0; 
	    int end = 0;
	    for(begin = 0; begin < cbEnds.length && !cbEnds[begin].isSelected(); begin++);
	    if(begin < cbEnds.length){
		cbEnds[begin].setSelected(false);
	    }
	    for(end = begin + 1; end < cbEnds.length && !cbEnds[end].isSelected(); end++);
	    if(end < cbEnds.length){
		cbEnds[end].setSelected(false);
	    }
	    if(end >= cbEnds.length){
		new ErrorMessage(this,"You did not select two endpoints!!!");
	    }
	    else{
		int x = end+1;
		for(x = end + 1; x < cbEnds.length; x++){
		    if(cbEnds[x].isSelected()){
			new ErrorMessage(this,"You selected more than two endpoints!!!");
			break;
		    }
		}
		if(x == cbEnds.length){
		    begin = begin * 2 + 1;
		    end = end * 2;
		    for(int i = 0; i < begin; i++){
			newpermutation[i] = permutation[i];
		    }
		    for(int i = begin; i <= end; i++){
			newpermutation[end + begin - i] = permutation[i];
		    }
		    for(int i = end + 1; i < permutation.length; i++){
			newpermutation[i] = permutation[i];
		    }
		    for(int i = 0; i < newpermutation.length; i++){
			//tfNumbers[i].setText(newpermutation[i]+"");
			setLabel(tfNumbers[i], i, newpermutation[i]);

		    }
		    permutations.add(actualIndex+1,newpermutation);
		    actualIndex++;
		    bPrev.setEnabled(true);
		    bDelete.setEnabled(true);
		    // pGraphPanel.getGraphics().dispose();
		    pGraphPanel.paintComponent(pGraphPanel.getGraphics());//show();
		}
	    }
	}
	if(e.getSource() == bDelete){
	    permutations.remove(actualIndex);
	    if(actualIndex > 0){
		actualIndex--;
	    }
	    if(permutations.size() == 1){
		bDelete.setEnabled(false);
	    }
	    int[] permutation = (int[])permutations.get(actualIndex);
	    for(int i = 0; i < permutation.length; i++){
		//tfNumbers[i].setText(permutation[i]+"");
		setLabel(tfNumbers[i], i, permutation[i]);

	    }
	    pGraphPanel.paintComponent(pGraphPanel.getGraphics());//show();
	}

   }

}

class DesireAndReality extends JPanel{

    InversionVisualisation owner;

    DesireAndReality(InversionVisualisation owner){
	this.owner = owner;
    }

    public void paintComponent(Graphics gr){
	gr.setColor(Color.WHITE);
	gr.fillPolygon(new int[] {0,getWidth(),getWidth(),0},
		       new int[] {0,0,getHeight(),getHeight()},
		       4);
	gr.setColor(Color.BLACK);
	int[] numbers = (int[])owner.permutations.get(owner.actualIndex);
	int[] inverse = new int[numbers.length];
	for(int i = 0; i < inverse.length; i++){
	    inverse[numbers[i]] = i;
	}
	boolean[] visited = new boolean[inverse.length];
	for(int i = 0; i < visited.length; i++){
	    visited[i] = false;
	}
	int width = getWidth();
	int height = getHeight();
	for(int i = 0; i < numbers.length/2; i++){
	    gr.drawLine((int)(width*2*i/numbers.length + width/(3*numbers.length)),height*9/10,
			(int)(width*(2*i+2)/numbers.length - width/(3*numbers.length)),height*9/10);
	}
	for(int i = 0; i < visited.length; i++){
	    if(!visited[i]){
		int j = i;
		while(!visited[j]){
		    visited[j] = true;
		    if(j%2 == 0){
			j++;
			gr.drawLine((width*(j+1)/numbers.length - width/(3*numbers.length)),height*9/10,
				    (width*(j+1)/numbers.length - width/(3*numbers.length))-10,height*9/10-10);
			gr.drawLine((width*(j+1)/numbers.length - width/(3*numbers.length)),height*9/10,
				    (width*(j+1)/numbers.length - width/(3*numbers.length))-10,height*9/10+10);
			visited[j] = true;
			j = inverse[numbers[j] + (numbers[j]%2 == 0 ? 1 : -1)];
		    }
		    else{
			j--;
			gr.drawLine((width*(j)/numbers.length + width/(3*numbers.length)),height*9/10,
				    (width*(j)/numbers.length + width/(3*numbers.length))+10,height*9/10-10);
			gr.drawLine((width*(j)/numbers.length + width/(3*numbers.length)),height*9/10,
				    (width*(j)/numbers.length + width/(3*numbers.length))+10,height*9/10+10);
			visited[j] = true;
			j = inverse[numbers[j] + (numbers[j]%2 == 0 ? 1 : -1)];			
		    }
		}
	    }
	}
	for(int i = 0; i < numbers.length; i++){
	    if(numbers[i]%2 == 0){
		int j = inverse[numbers[i] + 1];
		int x = (j>i ?
			 (int)(width*(i+1)/numbers.length - (i%2 == 0 ? width*2/(3*numbers.length) : width/(3*numbers.length))) :
			 (int)(width*(j+1)/numbers.length - (j%2 == 0 ? width*2/(3*numbers.length) : width/(3*numbers.length))));
		int y = (j<i ?
			 (int)(width*(i+1)/numbers.length - (i%2 == 0 ? width*2/(3*numbers.length) : width/(3*numbers.length))) :
			 (int)(width*(j+1)/numbers.length - (j%2 == 0 ? width*2/(3*numbers.length) : width/(3*numbers.length))));			 
		//	gr.setColor(Color.RED);
		//gr.drawLine(x,height*9/10,x,height);
		//gr.setColor(Color.BLUE);
		//gr.drawLine(y,height*9/10,y,height);
		//gr.setColor(Color.BLACK);
		int radius = (y-x);
		gr.setColor((i-j) % 2 == 0 ? Color.RED : Color.BLUE);
		gr.drawArc(x,height*9/10-radius/2,radius,radius,0, 180);
	    }
	}
	gr.setColor(Color.RED);
	for(int i = 1; i < numbers.length-1; i+=2){
	    if(numbers[i] < numbers[i+1]){
	    	gr.drawString(("+"+numbers[i+1]/2),(int)(width*(i+0.6666)/numbers.length),height*19/20);
	    }
	    else{
	    	gr.drawString(("-"+numbers[i]/2),(int)(width*(i+0.6666)/numbers.length),height*19/20);		
	    }
	}
    }

}
